/**
 * 0xGG Team
 * Distributed under AGPL3
 *
 * DESCRIPTION: Inline code fold that aims to get VickyWidgets work `@appname arg1=val1 arg2=val2`
 */

(function (mod){ //[HyperMD] UMD patched!
  /*commonjs*/  ("object"==typeof exports&&"undefined"!=typeof module) ? mod(null, exports, require("./fold"), require("../widget/timer/timer"), require("../widget/bilibili/bilibili"), require("../widget/youtube/youtube"), require("../widget/video/video"), require("../widget/error/error"), require("../widget/audio/audio")) :
  /*amd*/       ("function"==typeof define&&define.amd) ? define(["require","exports","./fold","../widget/timer/timer","../widget/bilibili/bilibili","../widget/youtube/youtube","../widget/video/video","../widget/error/error","../widget/audio/audio"], mod) :
  /*plain env*/ mod(null, (this.HyperMD.FoldWidget = this.HyperMD.FoldWidget || {}), HyperMD.Fold, HyperMD.WidgetTimer, HyperMD.WidgetBilibili, HyperMD.WidgetYoutube, HyperMD.WidgetVideo, HyperMD.WidgetError, HyperMD.WidgetAudio);
})(function (require, exports, fold_1, timer_1, bilibili_1, youtube_1, video_1, error_1, audio_1) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.WidgetFolder = function (stream, token) {
        if (token.type !== "inline-code" || !token.string.trim().startsWith("@")) {
            return null;
        }
        var start = token.start;
        var cm = stream.cm;
        var line = cm.getLine(stream.lineNo);
        var end = token.end;
        // TODO: variable `end` here might be wrong
        // TODO: Support multiple line inline_code
        for (; end < line.length; end++) {
            if (line[end] === "`" && line[end - 1] !== "\\") {
                break;
            }
        }
        var str = line.slice(start, end).trim();
        var widgetName;
        var widgetAttributes = {};
        var firstSpaceMatch = str.match(/\s/);
        var firstSpace = firstSpaceMatch ? firstSpaceMatch.index : -1;
        if (firstSpace > 0) {
            widgetName = str
                .slice(0, firstSpace)
                .trim()
                .replace(/^@/, "");
            try {
                widgetAttributes = JSON.parse("{" + str.slice(firstSpace + 1).trim() + "}");
            }
            catch (error) {
                widgetName = "error";
                widgetAttributes = { message: error.toString() };
            }
        }
        else {
            widgetName = str.trim().replace(/^@/, "");
        }
        if (!widgetName) {
            return null;
        }
        /*
        console.log("stream: ", stream);
        console.log("token: ", token);
        console.log("str: ", str);
        console.log("widgetName: ", widgetName);
        console.log("widgetAttributes: ", widgetAttributes);
        */
        var from = { line: stream.lineNo, ch: start };
        var to = { line: stream.lineNo, ch: end };
        var reqAns = stream.requestRange(from, to);
        if (reqAns !== fold_1.RequestRangeResult.OK)
            return null;
        // Create the widget
        var widget;
        if (widgetName === "timer") {
            widget = timer_1.TimerWidget(widgetAttributes);
        }
        else if (widgetName === "bilibili") {
            widget = bilibili_1.BilibiliWidget(widgetAttributes);
        }
        else if (widgetName === "youtube") {
            widget = youtube_1.YoutubeWidget(widgetAttributes);
        }
        else if (widgetName === "video") {
            widget = video_1.VideoWidget(widgetAttributes);
        }
        else if (widgetName === "audio") {
            widget = audio_1.AudioWidget(widgetAttributes);
        }
        else if (widgetName === "error") {
            widget = error_1.ErrorWidget(widgetAttributes);
        }
        else {
            return false;
        }
        // Create widget here
        var marker = cm.markText(from, to, {
            replacedWith: widget,
            collapsed: true
        });
        // 1 here means `
        widget.addEventListener("click", function () {
            fold_1.breakMark(cm, marker, 1), false;
        });
        return marker;
    };
    fold_1.registerFolder("widget", exports.WidgetFolder, true);
});
/*
example widget:

    `@timer "date":"Tue Dec 10 2019 10:54:07 GMT+0800 (China Standard Time)"`
*/
