var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};

(function (mod){ //[HyperMD] UMD patched!
  /*commonjs*/  ("object"==typeof exports&&"undefined"!=typeof module) ? mod(null, exports, require("markdown-it"), require("markdown-it-emoji"), require("markdown-it-footnote"), require("markdown-it-task-lists"), require("./features/math"), require("./features/tag"), require("./features/widget"), require("./features/fence"), require("../widget/timer/timer"), require("../widget/bilibili/bilibili"), require("../widget/youtube/youtube"), require("../widget/video/video"), require("../widget/audio/audio"), require("../widget/error/error"), require("../powerpack/fold-code-with-plantuml"), require("./transform"), require("./heading-id-generator"), require("./slide")) :
  /*amd*/       ("function"==typeof define&&define.amd) ? define(["require","exports","markdown-it","markdown-it-emoji","markdown-it-footnote","markdown-it-task-lists","./features/math","./features/tag","./features/widget","./features/fence","../widget/timer/timer","../widget/bilibili/bilibili","../widget/youtube/youtube","../widget/video/video","../widget/audio/audio","../widget/error/error","../powerpack/fold-code-with-plantuml","./transform","./heading-id-generator","./slide"], mod) :
  /*plain env*/ mod(null, (this.HyperMD.Preview = this.HyperMD.Preview || {}), MarkdownIt, MarkdownItEmoji, MarkdownItFootnote, MarkdownItTaskLists, HyperMD.PreviewFeatureMath, HyperMD.PreviewFeatureTag, HyperMD.PreviewFeatureWidget, HyperMD.PreviewFeatureFence, HyperMD.WidgetTimer, HyperMD.WidgetBilibili, HyperMD.WidgetYoutube, HyperMD.WidgetVideo, HyperMD.WidgetAudio, HyperMD.WidgetError, HyperMD.FoldCodeWithPlantUML, HyperMD.PreviewTransform, HyperMD.PreviewHeadingIDGenerator, HyperMD.PreviewSlide);
})(function (require, exports, markdown_it_1, markdown_it_emoji_1, markdown_it_footnote_1, markdown_it_task_lists_1, math_1, tag_1, widget_1, fence_1, timer_1, bilibili_1, youtube_1, video_1, audio_1, error_1, fold_code_with_plantuml_1, transform_1, heading_id_generator_1, slide_1) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    markdown_it_1 = __importDefault(markdown_it_1);
    markdown_it_emoji_1 = __importDefault(markdown_it_emoji_1);
    markdown_it_footnote_1 = __importDefault(markdown_it_footnote_1);
    markdown_it_task_lists_1 = __importDefault(markdown_it_task_lists_1);
    math_1 = __importDefault(math_1);
    tag_1 = __importDefault(tag_1);
    widget_1 = __importDefault(widget_1);
    fence_1 = __importDefault(fence_1);
    heading_id_generator_1 = __importDefault(heading_id_generator_1);
    var md = new markdown_it_1.default({
        html: true,
        linkify: true,
        typographer: true,
        breaks: true
    });
    md.use(markdown_it_emoji_1.default);
    md.use(markdown_it_footnote_1.default);
    md.use(markdown_it_task_lists_1.default);
    tag_1.default(md);
    math_1.default(md);
    widget_1.default(md);
    fence_1.default(md);
    /**
     * renderMarkdown
     * @param markdown
     */
    function renderMarkdown(markdown) {
        try {
            var _a = transform_1.transformMarkdown(markdown, {
                forPreview: true,
                headingIdGenerator: new heading_id_generator_1.default(),
                forMarkdownExport: false,
                usePandocParser: false
            }), slideConfigs = _a.slideConfigs, headings = _a.headings, outputString = _a.outputString, frontMatterString = _a.frontMatterString;
            var html = md.render(outputString);
            if (slideConfigs.length) {
                html = slide_1.parseSlides(html, slideConfigs);
                return {
                    html: html,
                    headings: headings,
                    slideConfigs: slideConfigs
                };
            }
            else {
                return {
                    html: html,
                    headings: headings,
                    slideConfigs: slideConfigs
                };
            }
        }
        catch (error) {
            return {
                html: "Failed to render markdown:\n" + JSON.stringify(error),
                headings: [],
                slideConfigs: []
            };
        }
    }
    exports.renderMarkdown = renderMarkdown;
    function performAfterWorks(previewElement) {
        renderWidgets(previewElement);
        renderCodeFences(previewElement);
    }
    /**
     * renderPreview
     * @param previewElement, which should be <div> element
     * @param markdown
     */
    function renderPreview(previewElement, markdown) {
        var _a = renderMarkdown(markdown), html = _a.html, headings = _a.headings, slideConfigs = _a.slideConfigs;
        if (!slideConfigs.length) {
            previewElement.innerHTML = html;
            performAfterWorks(previewElement);
        }
        else {
            var id_1 = "reveal.js." + Date.now();
            // Slide
            previewElement.innerHTML = "";
            var iframe_1 = document.createElement("iframe");
            iframe_1.style.border = "none";
            iframe_1.style.width = "100%";
            iframe_1.style.height = "100%";
            iframe_1.style.boxSizing = "border-box";
            previewElement.appendChild(iframe_1);
            iframe_1.contentWindow.document.write("<html>\n  <head>\n    <meta charset=\"utf-8\" />\n    <meta name=\"viewport\" content=\"width=device-width, initial-scale=1\" />\n    \n    <!-- reveal.js styles -->\n    <link rel=\"stylesheet\" href=\"https://cdn.jsdelivr.net/npm/reveal.js@3.8.0/css/reveal.css\">\n    <link rel=\"stylesheet\" href=\"https://cdn.jsdelivr.net/npm/reveal.js@3.8.0/css/theme/white.css\">\n\n    <!-- katex -->\n    <link rel=\"stylesheet\" href=\"https://cdn.jsdelivr.net/npm/katex@0.11.1/dist/katex.min.css\">\n\n    <!-- prism github theme -->\n    <link href=\"https://cdn.jsdelivr.net/npm/@shd101wyy/mume@0.4.7/styles/prism_theme/github.css\" rel=\"stylesheet\">\n  </head>\n  <body>\n  " + html + "\n  </body>\n  <!-- reveal.js -->\n  <script src=\"https://cdn.jsdelivr.net/npm/reveal.js@3.8.0/js/reveal.min.js\"></script>\n\n  <!-- prism.js -->\n  <script src=\"https://cdn.jsdelivr.net/npm/prismjs@1.17.1/prism.min.js\"></script>\n\n  <!-- initialize reveal.js -->\n  <script>\nReveal.initialize();\nReveal.addEventListener('ready', function(event) {\n  parent.postMessage({event: \"reveal-ready\", id:\"" + id_1 + "\"})\n})\n  </script>\n</html>");
            window.addEventListener("message", function (event) {
                if (event.data &&
                    event.data.event === "reveal-ready" &&
                    event.data.id === id_1) {
                    performAfterWorks(iframe_1.contentWindow.document.body);
                }
            });
        }
    }
    exports.renderPreview = renderPreview;
    function renderWidgets(previewElement) {
        // render widgets
        var widgets = previewElement.getElementsByClassName("vickymd-widget");
        for (var i = 0; i < widgets.length; i++) {
            var widgetSpan = widgets[i];
            var widgetName = widgetSpan.getAttribute("data-widget-name");
            var widgetAttributesStr = widgetSpan.getAttribute("data-widget-attributes");
            var widgetAttributes = {};
            try {
                widgetAttributes = JSON.parse(widgetAttributesStr);
            }
            catch (error) {
                widgetAttributes = {};
            }
            var widget = null;
            if (widgetName === "timer") {
                widget = timer_1.TimerWidget(widgetAttributes);
            }
            else if (widgetName === "bilibili") {
                widget = bilibili_1.BilibiliWidget(widgetAttributes);
            }
            else if (widgetName === "youtube") {
                widget = youtube_1.YoutubeWidget(widgetAttributes);
            }
            else if (widgetName === "video") {
                widget = video_1.VideoWidget(widgetAttributes);
            }
            else if (widgetName === "audio") {
                widget = audio_1.AudioWidget(widgetAttributes, false);
            }
            else if (widgetName === "error") {
                widget = error_1.ErrorWidget(widgetAttributes);
            }
            if (widget) {
                widget.classList.add("vickymd-widget");
                widget.setAttribute("data-widget-name", widgetName);
                widget.setAttribute("data-widget-attributes", widgetAttributesStr);
                widgetSpan.replaceWith(widget);
            }
        }
    }
    function renderCodeFences(previewElement) {
        var fences = previewElement.getElementsByClassName("vickeymd-fence");
        var copyFences = [];
        for (var i = 0; i < fences.length; i++) {
            // replaceChild will cause issue, therefore we need to make a copy of the original elements array
            copyFences.push(fences[i]);
        }
        for (var i = 0; i < copyFences.length; i++) {
            var fence = copyFences[i];
            var language = fence.getAttribute("data-info") || "text";
            var code = fence.textContent;
            // TODO: Diagrams rendering
            if (language.match(/^(puml|plantuml)$/)) {
                // Diagrams
                var el = fold_code_with_plantuml_1.PlantUMLRenderer(code, null);
                fence.replaceWith(el);
                continue;
            }
            else {
                // Normal code block
                var pre = document.createElement("pre");
                if (!window["Prism"]) {
                    pre.textContent = code;
                    fence.replaceWith(pre);
                    continue;
                }
                if (!(language in window["Prism"].languages)) {
                    pre.classList.add("language-text");
                    pre.textContent = code;
                    fence.replaceWith(pre);
                    continue;
                }
                try {
                    var html = window["Prism"].highlight(code, window["Prism"].languages[language], language);
                    pre.classList.add("language-" + language);
                    pre.innerHTML = html; // <= QUESTION: Is this safe?
                    fence.replaceWith(pre);
                    continue;
                }
                catch (error) {
                    pre.classList.add("language-error");
                    pre.textContent = error.toString();
                    fence.replaceWith(pre);
                    continue;
                }
            }
        }
    }
    /**
     * Print as PDF
     * @param previewElement
     */
    function printPDF(previewElement) {
        if (!window["html2pdf"]) {
            throw new Error("html2pdf is not imported. Failed to print pdf");
        }
        window["html2pdf"](previewElement);
    }
    exports.printPDF = printPDF;
});
