// 0xGG Team
// Distributed under AGPL3
//
// DESCRIPTION: This widget creates <audio> html element

(function (mod){ //[HyperMD] UMD patched!
  /*commonjs*/  ("object"==typeof exports&&"undefined"!=typeof module) ? mod(null, exports, require("../error/error")) :
  /*amd*/       ("function"==typeof define&&define.amd) ? define(["require","exports","../error/error"], mod) :
  /*plain env*/ mod(null, (this.HyperMD.WidgetAudio = this.HyperMD.WidgetAudio || {}), HyperMD.WidgetError);
})(function (require, exports, error_1) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    function AudioWidget(attributes, displayIcon) {
        if (displayIcon === void 0) { displayIcon = true; }
        var id = "_widget_audio_id_" + Math.round(1e9 * Math.random()).toString(36);
        var audioWrapper = document.createElement("span");
        audioWrapper.id = id;
        var audio = document.createElement("audio");
        audio.innerText = "Your browser does not support the audio element.";
        var src = attributes["src"];
        if (!src) {
            return error_1.ErrorWidget({ message: "Field 'src' is missing" });
        }
        if (attributes["autoplay"]) {
            audio.setAttribute("autoplay", attributes["autoplay"]);
        }
        if (attributes["controls"]) {
            audio.setAttribute("controls", attributes["controls"]);
        }
        if (attributes["loop"]) {
            audio.setAttribute("loop", attributes["loop"]);
        }
        if (attributes["muted"]) {
            audio.setAttribute("muted", attributes["muted"]);
        }
        if (attributes["style"]) {
            audio.setAttribute("style", attributes["style"]);
        }
        var source = document.createElement("source");
        source.setAttribute("src", src);
        var type = attributes["type"];
        if (type) {
            source.setAttribute("type", type);
        }
        audio.appendChild(source);
        audioWrapper.appendChild(audio);
        if (displayIcon && !attributes["controls"]) {
            // TODO: Hover display src
            var audioIcon = document.createElement("span");
            audioIcon.classList.add("widget-audio-icon");
            audioIcon.innerText = "🎵";
            audioWrapper.appendChild(audioIcon);
        }
        return audioWrapper;
    }
    exports.AudioWidget = AudioWidget;
});
/*
Example:

  `@audio "src":"https://raw.githubusercontent.com/shd101wyy/PlanetWalley/master/May4/songs/%E8%80%81%E7%94%B7%E5%AD%A9.mp3","autoplay":true`

*/
