// 0xGG Team
// Distributed under AGPL3
//
// DESCRIPTION: This widget displays time related information

(function (mod){ //[HyperMD] UMD patched!
  /*commonjs*/  ("object"==typeof exports&&"undefined"!=typeof module) ? mod(null, exports, require("../error/error")) :
  /*amd*/       ("function"==typeof define&&define.amd) ? define(["require","exports","../error/error"], mod) :
  /*plain env*/ mod(null, (this.HyperMD.WidgetTimer = this.HyperMD.WidgetTimer || {}), HyperMD.WidgetError);
})(function (require, exports, error_1) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    function TimerWidget(attributes) {
        var el = document.createElement("div");
        el.classList.add("widget-timer");
        el.style.padding = "4px 12px";
        el.style.backgroundColor =
            attributes["backgroundColor"] || "rgb(250, 145, 1)";
        el.style.color = attributes["color"] || "#fff";
        el.style.borderRadius = "16px";
        el.style.display = "flex";
        el.style.justifyContent = "space-between";
        el.style.width = "375px";
        el.style.maxWidth = "100%";
        el.style.boxShadow = "0 1px 3px 1px #aaa";
        if (!attributes["date"]) {
            return error_1.ErrorWidget({ message: "Field 'date' is missing." });
        }
        var dateEl = document.createElement("div");
        dateEl.classList.add("widget-timer-date");
        var date = new Date(attributes["date"]);
        dateEl.innerText = "⌚ " + date.toLocaleString();
        var durationEl = document.createElement("div");
        durationEl.classList.add("widget-timer-duraction");
        var duration = attributes["duration"] || "";
        if (duration) {
            duration = "🎬 " + duration;
        }
        durationEl.innerText = duration;
        el.appendChild(dateEl);
        el.appendChild(durationEl);
        return el;
    }
    exports.TimerWidget = TimerWidget;
});
