// 0xGG Team
// Distributed under AGPL3
//
// DESCRIPTION: This widget creates <video> html element

(function (mod){ //[HyperMD] UMD patched!
  /*commonjs*/  ("object"==typeof exports&&"undefined"!=typeof module) ? mod(null, exports, require("../error/error")) :
  /*amd*/       ("function"==typeof define&&define.amd) ? define(["require","exports","../error/error"], mod) :
  /*plain env*/ mod(null, (this.HyperMD.WidgetVideo = this.HyperMD.WidgetVideo || {}), HyperMD.WidgetError);
})(function (require, exports, error_1) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    function VideoWidget(attributes) {
        var id = "_widget_video_id_" + Math.round(1e9 * Math.random()).toString(36);
        var videoWrapper = document.createElement("div");
        videoWrapper.id = id;
        videoWrapper.style.position = "relative";
        videoWrapper.style.width = "100%";
        videoWrapper.style.height = "0";
        videoWrapper.style.paddingTop = "56.25%";
        var video = document.createElement("video");
        video.innerText = "Your browser does not support the video tag.";
        var src = attributes["src"];
        if (!src) {
            return error_1.ErrorWidget({ message: "Field 'src' is missing" });
        }
        if (attributes["autoplay"]) {
            video.setAttribute("autoplay", attributes["autoplay"]);
        }
        if (attributes["controls"]) {
            video.setAttribute("controls", attributes["controls"]);
        }
        if (attributes["loop"]) {
            video.setAttribute("loop", attributes["loop"]);
        }
        if (attributes["muted"]) {
            video.setAttribute("muted", attributes["muted"]);
        }
        if (attributes["poster"]) {
            video.setAttribute("poster", attributes["poster"]);
        }
        if (attributes["style"]) {
            video.setAttribute("style", attributes["style"]);
        }
        video.style.position = "absolute";
        video.style.left = "0";
        video.style.top = "0";
        video.style.width = "100%";
        video.style.height = "100%";
        var source = document.createElement("source");
        source.setAttribute("src", src);
        var type = attributes["type"];
        if (type) {
            source.setAttribute("type", type);
        }
        video.appendChild(source);
        videoWrapper.appendChild(video);
        return videoWrapper;
    }
    exports.VideoWidget = VideoWidget;
});
